

````json
{
  "openapi": "3.0.0",
  "info": {
    "title": "Unity Advertising Management API",
    "version": "v1.0 latest",
    "contact": {
      "name": "Unity Support",
      "url": "https://support.unity.com/"
    },
    "description": "# Introduction\n\nThe Management API is a streamlined solution designed to automate and optimize your acquire advertising operations.\nIt offers dynamic apps & campaign management, budget allocation and creative management through robust API endpoints.\nThis translates into a reduced manual workload and an increase in dynamic, data-driven decision-making capabilities.\n\n**With Management API you can:**\n\n* Automate bulk campaign & app creation and adjustments\n* Seamlessly adjust budget allocations for your campaigns\n* Efficiently manage and assign your creatives and creative packs\n\n**How to use this documentation?**\n\n* The <a href=\"#section/Get-Started\">Get Started</a> guide will help you set up the Service account and start using the API\n* The <a href=\"#section/Basic-Concepts\">Basic Concepts</a> section will provide you with general information about the Management API, including API structure, versioning, and deprecation policy\n* The <a href=\"#tag/Apps\">Endpoints section</a> has all the information about actual API endpoints and error handling\n\nIf you have any questions or feedback regarding the API you can reach out to us at unityads-support@unity3d.com.\n\n# Get Started\n\nPrerequisites: You have the Unity account.\n\nTo get started, you will first need to create a service account and assign suitable roles for it. Note that you must be an \n[Organization Owner](https://docs.unity3d.com/Manual/OrgsManagingyourOrganization.html) to manage service accounts.\n\n**How to Gain Access?**\n\n**Note**: To be able to access the API and to create service accounts, your organization needs to have access granted\nto the Advertising Management API. Please contact\nyour Unity Client Partner or email us at unityads-support@unity3d.com.\n\n## Set up a service account\n\nYou can find information on how to create a service account\n[here](https://services.docs.unity.com/docs/service-account-auth/#create-a-service-account).\n\nAfter the service account has been created, you will need to authenticate an API and choose the roles that would be assigned to it.\n\n## Authentication & Authorization\n\nTo learn how to authenticate your requests, please visit the\n[Admin API authentication page](https://services.docs.unity.com/docs/service-account-auth/#authenticate-an-api-using-service-account-credentials)\n\n## Roles and Permissions\n\nThe service account must have the relevant access to be able to call the APIs. Please see below for the available\nservice account roles and their corresponding access rights:\n\n| Role                                | Access Rights                                                                                                 |\n|-------------------------------------|---------------------------------------------------------------------------------------------------------------|\n| Advertise API Admin                 | Grants full read and write access.                                                                            |\n| Advertise API Viewer                | Grants access to all the read endpoints.                                                                      |\n| Advertise API Apps Editor           | Grants access to all the read and update endpoints for apps.                                                  |\n| Advertise API Campaigns Editor      | Grants access to all the read and update endpoints for campaigns.                                             |\n| Advertise API Bids Editor           | Grants access to all the read and update endpoints for all the bid types.                                     |\n| Advertise API Creative Packs Editor | Grants access to all the read and update endpoints for creatives, creative packs and assigned creative packs. |\n| Advertise API Targeting Editor      | Grants access to all the read and update endpoints for targeting options.                                     |\n\nYou can learn more about the roles available for Management API on the\n[Admin API authentication page](https://services.docs.unity.com/docs/service-account-auth/#available-roles) under Growth section.\n\n## First Call: List Apps\n\nLearn how to send your first API request with Management API. Before we start, please make sure that you have set up a [Service Account](https://services.docs.unity.com/docs/service-account-auth/#create-a-service-account) with necessary [roles](#section/Get-Started/Roles-and-Permissions).\nThe first call we will perform is [List Apps](#tag/Apps/operation/advertise_listApps) `GET` request. To be able to perform this request, the service account needs to have one of the following roles:\n\n* Advertise API Viewer\n* Advertise API Apps Editor\n* Advertiser API Admin\n\nIn this guide, we are going to be using the `curl` command line tool in the Unix terminal.\n\nFollow these steps:\n\n### Step 1\n\nThe key ID and secret key that you should have gotten as part of the service account setup should be Base64 encoded before authenticating an API with the Unix terminal. Assuming you have key ID `7e0f1152-e0dd-4b14-8e37-04cab07efeb0` and secret key `NKxoRp2m2w3e9gzJfssNQnTfypFgtJn7`, the following command will Base64 encode the key string:\n\n```\necho -n \"7e0f1152-e0dd-4b14-8e37-04cab07efeb0:NKxoRp2m2w3e9gzJfssNQnTfypFgtJn7\" | base64\n```\n\nIn the output you should get a string that looks like this: `N2UwZjExNTItZTBkZC00YjE0LThlMzctMDRjYWIwN2VmZWIwOk5LeG9ScDJtMnczZTlnekpmc3NOUW5UZnlwRmd0Sm43`.\n\n### Step 2\n\nGet the organization ID following the guide in the [Resource IDs](#section/Basic-Concepts/Resource-IDs-Used-in-the-API-Calls) section. You should end up with an ID that looks like this: `5772562874846`.\n\n### Step 3\n\nConstruct the API call URL. For the [List Apps](#tag/Apps/operation/advertise_listApps) endpoint, it has the following format: `https://services.api.unity.com/advertise/v1/organizations/{organizationId}/apps`. If we use the organization ID from the previous step, the full URL is going to be `https://services.api.unity.com/advertise/v1/organizations/5772562874846/apps`.\n\n### Step 4\n\nLet's put all the pieces together and construct the `curl` command that will perform the [List Apps](#tag/Apps/operation/advertise_listApps) request:\n\n```\ncurl -H \"Authorization: Basic N2UwZjExNTItZTBkZC00YjE0LThlMzctMDRjYWIwN2VmZWIwOk5LeG9ScDJtMnczZTlnekpmc3NOUW5UZnlwRmd0Sm43\" \\\n https://services.api.unity.com/advertise/v1/organizations/5772562874846/apps\n```\n\nIf your organization has multiple apps, you can consider limiting the number of returned apps to make it easier to check the result. It can be done by adding the `limit` query parameter:\n\n```\ncurl -H \"Authorization: Basic N2UwZjExNTItZTBkZC00YjE0LThlMzctMDRjYWIwN2VmZWIwOk5LeG9ScDJtMnczZTlnekpmc3NOUW5UZnlwRmd0Sm43\" \\\n https://services.api.unity.com/advertise/v1/organizations/5772562874846/apps?limit=1\n```\n\n### Step 5\n\nCheck the `curl` output. If your organization does not have any apps, the result will look like this:\n\n```json\n{\"total\":0,\"offset\":0,\"limit\":1000,\"results\":[]}\n```\n\nIf your organization has apps, the result will contain a list of apps:\n\n```json\n{\"total\":10,\"offset\":0,\"limit\":1,\"results\":[{\"id\":\"651bffb0c4466ba162a56531\",\"name\":\"My awesome game\",\"store\":\"apple\",\"storeId\":\"1358236\",\"gameId\":500269499,\"adomain\":null,\"createdAt\":\"2023-10-03T11:49:04.953Z\",\"updatedAt\":\"2023-10-03T11:49:04.953Z\"}]}\n```\n\n### Step 6\n\n**Congratulations!** You’re ready to manage your apps and campaigns with the Management API.\n\nFeel free to let us know what you think of this guide: unityads-support@unity3d.com.\n\n# Basic Concepts\n\n## Overview\n\nThe guides in this series provide an overview of the entities, methods and endpoints available in the Management API.\nAfter reading these guides, you will understand the following key concepts:\n\n* How the Management API is structured\n* How Management API versioning works\n* Which API endpoints to use to retrieve entities\n* Which API endpoints to use to modify entities\n* How to structure and sequence API calls\n\nThe API endpoints are hosted at the following base URL: https://services.api.unity.com.\n\n## Glossary\n\nThis section provides a more detailed explanation of the vocabulary used in the API.\n\n### Apps and Campaigns\n\n| Entity                     | Description                                                                                                     |\n|----------------------------|-----------------------------------------------------------------------------------------------------------------|\n| [App](#tag/Apps)           | App that is published in an app store and contains a set of campaigns. Apps are identified by campaignSetId.    |\n| [Campaign](#tag/Campaigns) | Campaign holds the details of your advertisement campaign such as which bids to set and which ad assets to use. |\n\n### Bid Types\n\n| Entity                                                  | Description                                                                                                                                                                   |\n|---------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n| [CPI Bid](#tag/Bids/operation/advertise_listCpiBids)             | CPI (cost per install) bids are used for targeting and pricing on a per-country basis within your ad campaign.                                                                |\n| [Source Bid](#tag/Bids/operation/advertise_listSourceBids)       | Source bids are used for granularly targeting and pricing apps (sources) on a per-country basis within your ad campaign.                                                      |\n| [ROAS Bid](#tag/Bids/operation/advertise_listRoasBids)           | ROAS (Return On Ad Spend) bids are dynamically priced bids that are used for targeting users that are predicted to generate revenue through in-app purchases or watching ads. |\n| [Retention Bid](#tag/Bids/operation/advertise_listRetentionBids) | Retention bids are dynamically priced bids that are used for targeting users that are likely to remain in your game 7 days after install.                                     |\n\n### Creative Packs and Creatives\n\n| Entity                               | Description                                                                                                                                                                                                                                               |\n|--------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n| [Creative](#tag/Creatives)           | Creative holds either one or two ad assets (files). More information about creative types can be found in the [Creative Types](#section/Basic-Concepts/Glossary/Creative-Types) section.                                                                  |\n| [Creative Pack](#tag/Creative-Packs) | A creative pack combines 1-3 creatives, or 1-10 banner creatives, into one entity that can be assigned to one or more campaigns. More information about creative pack types can be found in the [Creative Pack Types](#section/Basic-Concepts/Glossary/Creative-Pack-Types) section. |\n\n### <a name=\"section/Basic-Concepts/Glossary/Creative-Types\"></a>Creative Types\n\n| Creative Type     | Description                                                                                                                                                                                                               |\n|-------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n| End Card Creative | End cards are creative assets displayed at the end of a video with a call to action for users to download the advertised product. It can be either a single square image or combination of portrait and landscape images. |\n| Playable Creative | Playable ads allow users to play a quick interactive demo of your game.                                                                                                                                                   |\n| Video Creative    | Video creative is a video that is used for marketing your app.                                                                                                                                                            |\n| Banner Creative   | Banner creatives are static images shown in a banner ad placement. They cannot be uploaded through this API.                                                                                                              |\n\n### <a name=\"section/Basic-Concepts/Glossary/Creative-Pack-Types\"></a>Creative Pack Types\n\n| Creative Pack Type          | Description                                                                                                                      |\n|-----------------------------|----------------------------------------------------------------------------------------------------------------------------------|\n| Video and static end card   | A video ad with an image-type end card. Consists of 1 or 2 Video creatives (portrait/landscape) and one End Card creative.       |\n| Playable                    | A playable is an interactive ad. Includes only Playable creative.                                                                |\n| Video and playable end card | A video ad with an interactive-type end card. Consists of 1 or 2 Video creatives (portrait/landscape) and one Playable creative. |\n| Banner                      | A banner ad. Consists of 1 to 10 Banner creatives. Banner creative packs cannot be created through this API.                     |\n\n\n## Entity Relationships\n\nThis section provides an overview on what the different resources in the API are and how they relate to each other.\n\nAt the top level, the API has a resource that is called `App`. The `App` resource corresponds to a single app/game\nthat has been published in a single app store. If you have published your app/game in more than one app store then\nyou will have a separate `App` resource for each of those stores. Note that it is also possible to have more than one\n`App` resources that correspond to the same app/game in a store. The following diagram visualizes this relationship\nfor a game called `My Game`:\n\n```mermaid\n  graph TD\n\n  StoreApp1(My Game for Platform X) --- AdsApp1\n  StoreApp2(My Game for Platform Y) --- AdsApp2\n\n  subgraph App Store 1\nStoreApp1\n  end\n\n  subgraph App Store 2\nStoreApp2\n  end\n\n  subgraph Unity Ads\nAdsApp1(App) --- Resources1-1(\"...\")\nAdsApp1 --- Resources1-2(\"...\")\nAdsApp1 --- Resources1-3(\"...\")\n\nAdsApp2(App) --- Resources2-1(\"...\")\nAdsApp2 --- Resources2-2(\"...\")\nAdsApp2 --- Resources2-3(\"...\")\n  end\n\n  classDef grey fill:#eee,stroke:#333,stroke-width:1px;\n  classDef white fill:#fff,stroke:#333,stroke-width:1px;\n  classDef green fill:#9f9,stroke:#333,stroke-width:1px;\n  classDef blue fill:#1e60ab,color:#fff,stroke:#333,stroke-width:1px;\n  classDef red fill:#f33,color:#fff,stroke:#333,stroke-width:1px;\n\n  class StoreApp1,StoreApp2 grey\n  class AdsApp1,AdsApp2 white\n  class Resources1-1,Resources2-1 blue\n  class Resources1-2,Resources2-2 green\n  class Resources1-3,Resources2-3 red\n```\n\nApps contain advertisement campaigns and resources related to those campaigns such as budgets, bids and creatives:\n\n```mermaid\n  graph TD\n\n  subgraph Unity Ads\nApp ---|has| Creative(\"Creative (Video, Playable or End Card)\")\nApp ---|has| CreativePack(Creative Pack)\nApp(App) ---|has| Campaign(Campaign)\nCreativePack -.-|uses| Creative\nCampaign -.-|uses| CreativePack\nCampaign --- Bid(CPI bids and Source Bids)\nCampaign ---|has| Budget(Budget)\n  end\n\n  classDef white fill:#fff,stroke:#333,stroke-width:1px;\n  classDef green fill:#9f9,stroke:#333,stroke-width:1px;\n  classDef blue fill:#1e60ab,color:#fff,stroke:#333,stroke-width:1px;\n  classDef red fill:#f33,color:#fff,stroke:#333,stroke-width:1px;\n\n  class App white\n  class Campaign,Bid blue\n  class Creative,CreativePack green\n  class Budget red\n```\n\n## Resource IDs Used in the API Calls\n\nTo identify your organization as well as its apps and campaigns we use the following identifiers:\n\n* **organizationId**: identifies your organization\n* **campaignSetId**: identifies your app (collection of campaigns) within your organization\n* **campaignId**: identifies a single advertising campaign within your app\n\n### How to Look Up organizationId\n\nTo look up the `organizationId`, please use the following steps:\n1. Open the [Acquire Dashboard](https://dashboard.unity3d.com/acquire)\n2. Select **Settings** from the navigation.\n3. On the settings page, you will see two separate Organization ID fields. For the Advertising Management API, pick\nthe value from the `Organization Core ID` field.\n\n**Note**: The organizations are identified with two separate identifiers due to legacy reasons. The full name of the\norganization identifier used in the Advertising Management API is `Organization Core ID` but due to practical reasons\nit has been shortened to be `organizationId` in this API documentation.\n\n### How to Look Up campaignSetId and campaignId\n\nTo look up the `campaignSetId` and `campaignId`, the following options are available:\n\nApps and their respective campaignSetIds can be retrieved using the [List Apps](#tag/Apps/operation/advertise_listApps)\nendpoint. In the API response, the `id`-field holds the campaignSetId. Likewise, campaigns and their respective\ncampaignIds can be retrieved using the [List Campaigns](#tag/Campaigns/operation/advertise_listCampaigns) endpoint.\n\nThe campaignSetId and campaignId identifiers are also available via the [Advertising Statistics API](https://services.docs.unity.com/statistics/v2/)\nwhere you can find them under the columns `app id` and `campaign id`, respectively.\n\nIt is also possible to find all the identifiers from the URLs of the Unity Acquire dashboard. First, open the\n[dashboard](https://dashboard.unity3d.com/acquire/) and then click **Apps** and choose an app and a campaign to view.\nAfter that the IDs are visible in the URL in following spots:\n`https://dashboard.unity3d.com/organizations/<ORGANIZATION_ID>/acquire/campaign-sets/<CAMPAIGN_SET_ID>/campaigns/<CAMPAIGN_ID>`\n\n## Versioning\n\nOur API endpoints are versioned and typically structured in the following format:\n\n```text\n<BASE_URL>/<VERSION>/<API_NAMESPACE>/<...>\n```\n\nwhere `<VERSION>` is the version number of the API (example: v1).\n\nThe API may receive non-breaking changes without its version number being changed. Breaking changes are introduced only to new API versions.\n\nThe current API version is **v1**. For all API updates, view our API <a href=\"#change-log\">changelog</a>.\n\n\n### Breaking/Non-breaking Changes Explained\n\nNon-breaking changes can include (but are not limited to) for example:\n\n* Adding new optional request headers\n* Adding new fields to the response\n* Adding new status codes to the response status codes list\n* Changing a required field to be optional\n* Changes to rate limits\n* Under-the-hood fixes that don’t change the URL signature, the request format or the response format\n\nBreaking changes can include (but are not limited to) for example:\n\n* Changing the URL signature\n* Removing a field from the response\n* Adding a new required field to the request\n* Removing endpoints\n* Behavioral changes in filters or options\n* Request format alterations for endpoints\n\n\n### Deprecation Policy\n\nIf a newer version of the API is released or if the service is discontinued, the API or one of its versions may be\ndeprecated and eventually shutdown.\n\nDeprecation of an API version will occur in 2 steps:\n\n1. Unity's client partner or support team will email Organization owners, informing them of the new version's imminent\n   release and the current version's deprecation date. A deprecation notice will appear on the HTTP headers of any\n   deprecated API, and the documentation will be updated as such.\n2. After 3 months of continued support for a deprecated version, Unity may cease support or shut down the version\n   entirely. A complete shutdown notice will be sent 1 month in advance.\n\n### Feature Release Lifecycle\n\nThe Management API is designed to mirror the feature lifecycle stages — Closed Beta, Open Beta, and General Availability (GA)\n— ensuring a seamless user experience. If you have access to a feature in the Closed Beta phase within the platform,\nyou can expect parallel API-level access. This congruency extends through the Open Beta and onto GA,\noffering a consistent interface for interactions and functionality.\nIn essence, API capabilities evolve in tandem with the feature's lifecycle for a unified workflow.\n\nIf you find that a feature you have access to isn't available on the Management API,\nplease reach out to your Client Partner or contact our support team for assistance at unityads-support@unity3d.com.\n\n## Rate Limits\n\nThe API has rate limiting in place. The maximum number of requests per IP address is limited to 10 to 20 requests per\nsecond and to 4000 requests per 30 minutes.\n\nAdditionally, all operations that modify resources (`PUT`, `PATCH`, `DELETE`) are limited so that it is possible to modify\na single resource per endpoint at most 100 times per 30 minutes or at most once per a second. This means that for example\nthe CPI bids of a single campaign can be updated at most 30 times inside a 30-minute time interval. The endpoints\ndon't share the quota, so it is possible to do also other updates (e.g. source bids) to that same campaign during that\nsame time interval.\n\nSimilarly, operations that create resources (`POST`) are limited so that it is possible to create at most 30 new\nresources per endpoint under a single app or campaign per 30 minutes or at most once per a second. This means that\nit is possible to for example upload at most 30 creatives into a single app within a 30-minute interval.\nDuring that same time window it is possible to also create other resources or apply updates to the campaigns that\nare under the app. Each endpoint has its own quota.\n\nIf you need to update multiple campaigns fast, you can do that. It is for example possible to update CPI bids of hundreds\nof campaigns within a short time interval, as long as the number of requests stays in the overall bounds of max 6 to 10 requests\nper second and max 4000 requests per 30 minutes.\n\nThe API responds with `429` HTTP status code if the rate limit is exceeded.\n\n**Quick Reference**\n\n| What is limited                                            | How many requests are allowed per second  | How many requests are allowed per 30 minutes  | Notes                                                                                                                                                                                                                                        |\n|------------------------------------------------------------|-------------------------------------------|-----------------------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n| <a href=\"#tag/Apps\">Apps</a> endpoints                     | 20                                         | 4000                                          | Takes all requests into account.                                                                                                                                                                                                             |\n| <a href=\"#tag/Bids\">Bids</a> endpoints                     | 10                                        | 4000                                          | Takes all requests into account.                                                                                                                                                                                                             |\n| <a href=\"#tag/Campaigns\">Campaigns</a> endpoints           | 20                                         | 4000                                          | Takes all requests into account.                                                                                                                                                                                                             |\n| <a href=\"#tag/Creatives\">Creatives</a> endpoints           | 20                                         | 4000                                          | Takes all requests into account.                                                                                                                                                                                                             |\n| <a href=\"#tag/Creative-Packs\">Creative-Packs</a> endpoints | 20                                         | 4000                                          | Takes all requests into account.                                                                                                                                                                                                             |\n| `PUT`, `PATCH`, `DELETE`                                   | 1                                         | 100                                            | Applied per `Campaign`, `Creative` or `Creative Pack` for each endpoint separately.                                                                                                                                                          |\n| `POST`                                                     | 1                                         | 30                                            | Applied per `App` endpoint for those resources that are directly under the `App` such as `Campaigns`. If the resource in question is under `Campaign`, such as `Creative Pack Assignment` then the limit is applied per `Campaign` endpoint. |\n\n**RateLimit HTTP Headers**\n\nEvery successful response includes `RateLimit HTTP headers`, providing essential information about the maximum limit per endpoint and the remaining quota.\nFor example, utilizing the \"Unity-RateLimit\" header assists in calculating the average number of requests per second.\nYou can read more about the RateLimit HTTP headers <a href=\"/docs/headers/\" target=\"_blank\">here</a>.\n\n\n## Response Compression\n\nThe API supports response compression. The responses are compressed if either `Accept-Encoding: gzip` or\n`Accept-Encoding: deflate` header is provided in the request.\n\nExample:\n```\ncurl -H \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" -H \"Accept-Encoding: gzip\" https://services.api.unity.com/advertise/v1/organizations/5772680389521/apps/5ee23a52c10f9455722a5ead/campaigns/5ee23a557de7e87ee0958dfc/source-bids\n```\n\n# Change Log\n\n<details>\n<summary>This changelog lists all additions and updates to the Management API, in chronological order.</summary>\n\n**September 21, 2026**\n\n* Added `banner` to the creative `type` values returned by the <a href=\"#tag/Creatives\">Creatives</a> endpoints, and to the creative pack `type` values returned by the <a href=\"#tag/Creative-Packs\">Creative Packs</a> endpoints.\n* The <a href=\"#tag/Creative-Packs\">Creative Packs</a> endpoints may now return more than three `creativeIds`, as banner creative packs can hold up to ten creatives.\n* Banner creatives cannot be uploaded through this API.\n\n**January 10, 2025**\n\n* Added support for <a href=\"#tag/Creatives/operation/advertise_updateCreativePack\">Update Creative Pack</a> endpoint.\n* Added support for `appleProductPageId`-field and `androidStoreListing`-field in the <a href=\"#tag/Creative-Packs\">Creative Packs</a> endpoints.\n\n**January 10, 2024**\n\n* Added pagination support for <a href=\"#tag/Creatives/operation/advertise_listCreatives\">List Creatives</a> endpoint.\n\n**January 2, 2024**\n\n* Added support for updating partial bids in the <a href=\"#tag/Bids\">Bids</a> endpoints.\n\n**December 14, 2023**\n\n* Added support for requesting additional campaign data in <a href=\"#tag/Campaigns/operation/advertise_getCampaign\">get campaign</a> endpoint.\n\n**October 16, 2023**\n\n* Added support for regional targeting in <a href=\"#tag/Campaigns/operation/advertise_getTargeting\">retrieving a campaign targeting options</a> and <a href=\"#tag/Campaigns/operation/advertise_updateTargeting\">updating a campaign targeting options</a>.\n\n**October 02, 2023**\n\n* Added support for category targeting in <a href=\"#tag/Campaigns/operation/advertise_getTargeting\">retrieving a campaign targeting options</a> and <a href=\"#tag/Campaigns/operation/advertise_updateTargeting\">updating a campaign targeting options</a>.\n\n**September 21, 2023**\n\n* Added support for screen density in <a href=\"#tag/Campaigns/operation/advertise_getTargeting\">retrieving a campaign targeting options</a> and <a href=\"#tag/Campaigns/operation/advertise_updateTargeting\">updating a campaign targeting options</a>.\n\n**September 20, 2023**\n\n* Added support for screen size in <a href=\"#tag/Campaigns/operation/advertise_getTargeting\">retrieving a campaign targeting options</a> and <a href=\"#tag/Campaigns/operation/advertise_updateTargeting\">updating a campaign targeting options</a>.\n* Added support for connection type in <a href=\"#tag/Campaigns/operation/advertise_getTargeting\">retrieving a campaign targeting options</a> and <a href=\"#tag/Campaigns/operation/advertise_updateTargeting\">updating a campaign targeting options</a>.\n\n**September 19, 2023**\n\n* Added support to filter Campaign by status in the <a href=\"#tag/Campaigns/operation/advertise_listCampaigns\">list Campaigns</a> endpoint by `enabled`.\n\n**August 07, 2023**\n\n* Added support for Creative Testing campaign in the <a href=\"#tag/Bids\">Bids</a> endpoints.\n\n**April 13, 2023**\n\n* Added support for Creative Testing campaign in the <a href=\"#tag/Campaigns\">Campaigns</a> endpoints.\n\n**March 8, 2023**\n\n* Updated the <a href=\"#section/Basic-Concepts/Rate-Limits\">Rate Limits</a> policy.\n\n**February 15, 2023**\n\n* Added support for `gameId`-field to the response body of <a href=\"#tag/Apps/operation/advertise_createApp\">create App</a> and <a href=\"#tag/Apps/operation/advertise_getApp\">get App</a> and <a href=\"#tag/Apps/operation/advertise_listApps\">list Apps</a> endpoints.\n\n**February 1, 2023**\n\n* Added support for three decimal bids in the <a href=\"#tag/Bids\">Bids</a> endpoints.\n\n**January 17, 2023**\n\n* Removed deprecated shared budgets endpoints. Please use campaign budget endpoints instead.\n\n**January 14, 2023**\n\n* Added support for setting unlimited campaign budget for campaigns with manual biddingStrategy by supporting 0 in <a href=\"#tag/Campaigns/operation/advertise_updateCampaignBudget\">update campaign budget</a> endpoint.\n\n**December 14, 2022**\n\n* Added support for three decimal bids in the <a href=\"#tag/Bids\">Bids</a> endpoints for the Closed Beta participants.\n\n**November 24, 2022**\n\n* Added support for `postInstallWindow`-field to the request body of <a href=\"#tag/Campaigns/operation/advertise_createCampaign\">create Campaign</a> endpoint.\n\n**September 19, 2022**\n\n* Added support for `biddingStrategy`-field to the request body of <a href=\"#tag/Campaigns/operation/advertise_createCampaign\">create Campaign</a> endpoint.\n\n**September 5, 2022**\n\n* Added new endpoints for <a href=\"#tag/Campaigns/operation/advertise_getCampaignBudget\">getting</a> and <a href=\"#tag/Campaigns/operation/advertise_updateCampaignBudget\">updating a campaign budget</a>.\n\n**August 31, 2022**\n\n* Added `biddingStrategy`-field to the response body of <a href=\"#tag/Campaigns/operation/advertise_getCampaign\">get Campaign</a> and <a href=\"#tag/Campaigns/operation/advertise_listCampaigns\"> list Campaigns</a> endpoints.\n\n**July 27, 2022**\n\n* Added `billingType`-field to the request body of <a href=\"#tag/Campaigns/operation/advertise_createCampaign\">create campaign</a> endpoint.\n\n**May 12, 2022**\n\n* Added support for <a href=\"#tag/Apps/operation/advertise_deleteApp\">deleting an app</a>.\n\n**May 6, 2022**\n\n* Added support for <a href=\"#tag/Apps/operation/advertise_updateApp\">updating an app</a>.\n\n**May 3, 2022**\n\n* Added `adomain`-field to the request body of <a href=\"#tag/Apps/operation/advertise_createApp\">create App</a> endpoint.\n\n**April 19, 2022**\n\n* Added `adomain`-field to the responses of <a href=\"#tag/Apps/operation/advertise_getApp\">get App</a> and <a href=\"#tag/Apps/operation/advertise_listApps\">list Apps</a> endpoints.\n\n**January 28, 2022**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_getTargeting\">retrieving a campaign targeting options</a>.\n\n**January 26, 2022**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_updateTargeting\">updating targeting options</a>.\n\n**December 16, 2021**\n\n* Increased the <a href=\"#section/Basic-Concepts/Rate-Limits\">default rate limit</a> to 6 requests per second.\n\n**December 10, 2021**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_getCampaignBudget\">retrieving a campaign Budget</a>.\n\n**December 2, 2021**\n\n* Added support to filter Apps in the <a href=\"#tag/Apps/operation/advertise_listApps\">list Apps</a> endpoint by `store` and `storeId`.\n\n**November 29, 2021**\n\n* Added support for <a href=\"#tag/Apps/operation/advertise_getApp\">retrieving an app</a>.\n\n**November 25, 2021**\n\n* Added support for <a href=\"#tag/Apps/operation/advertise_createApp\">creating apps</a>.\n\n**November 15, 2021**\n\n* Make the `storeId` field nullable in the App listing endpoint.\n\n**October 14, 2021**\n\n* Added support for creating playable creatives.\n\n**October 11, 2021**\n\n* Fixed some error messages for enabled campaigns that were referring to them as \"live\" campaigns.\n\n**October 1, 2021**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_updateCampaign\">updating a campaign</a>.\n\n**September 28, 2021**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_deleteCampaign\">deleting a campaign</a>.\n\n**September 21, 2021**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_createCampaign\">campaign creation</a>.\n\n**September 10, 2021**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_getCampaign\">retrieving a Campaign</a>.\n\n**September 6, 2021**\n\n* Fixed an issue that caused the <a href=\"#tag/Campaigns/operation/advertise_updateCampaignBudget\">update Campaign Budget</a> endpoint to have too strict rate limit.\n\n**September 1, 2021**\n\n* Changed the <a href=\"#tag/Campaigns/operation/advertise_listCampaigns\">list Campaigns</a> endpoint to include `enabled, attributionClickUrl, attributionStartUrl, scheduleStart, scheduleEnd` fields.\n\n**August 23, 2021**\n\n* Added pagination support for <a href=\"#tag/Creative-Packs/operation/advertise_listCreativePacks\">list Creative Packs</a> endpoint.\n\n**August 13, 2021**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_createCampaignBudget\">create Campaign Budget</a> endpoint.\n\n**July 27, 2021**\n\n* Added support for **Video and Playable** creative pack type in the <a href=\"#tag/Creative-Packs/operation/advertise_createCreativePack\">create creative pack endpoint</a>.\n\n**July 26, 2021**\n\n* Added support for <a href=\"#tag/Bids/operation/advertise_listRetentionInfo\">listing Retention information</a>.\n\n**July 22, 2021**\n\n* Added support for <a href=\"#tag/Bids/operation/advertise_replaceRetentionBids\">replace Retention bids</a>.\n\n**July 20, 2021**\n\n* Added support for <a href=\"#tag/Bids/operation/advertise_listRetentionBids\">listing Retention bids</a>.\n\n**July 19, 2021**\n\n* Added `storeId`-field to the responses of <a href=\"#tag/Apps/operation/advertise_listApps\">list Apps</a> endpoint.\n\n**July 14, 2021**\n\n* Added support for <a href=\"#tag/Bids/operation/advertise_listRoasInfo\">listing ROAS information</a>.\n\n**July 7, 2021**\n\n* Changed the <a href=\"#tag/Campaigns/operation/advertise_listCampaigns\">list Campaigns</a> endpoint to include the ROAS types field for ROAS campaigns.\n\n**July 7, 2021**\n\n* Added support to filter creative packs in the <a href=\"#tag/Creative-Packs/operation/advertise_listCreativePacks\">list Creative Packs</a> endpoint by name.\n\n**July 2, 2021**\n\n* Added `campaignIds`-field to the responses of <a href=\"#tag/Creative-Packs/operation/advertise_getCreativePack\">get\n  Creative Pack</a> and <a href=\"#tag/Creative-Packs/operation/advertise_listCreativePacks\">list Creative Packs</a> endpoints.\n\n**July 1, 2021**\n\n* Added support for <a href=\"#tag/Bids/operation/advertise_replaceRoasBids\">replace ROAS (Return On Ad Spend) bids</a>.\n\n**June 30, 2021**\n\n* Changed the <a href=\"#tag/Bids/operation/advertise_listCpiBids\">list CPI bids</a> and <a href=\"#tag/Bids/operation/advertise_listSourceBids\">list source bids</a> endpoints to return a 404 error if the campaign type is not Installs.\n\n**June 23, 2021**\n\n* Changed support contact address to unityads-support@unity3d.com.\n\n**June 17, 2021**\n\n* Added support for <a href=\"#tag/Bids/operation/advertise_listRoasBids\">listing ROAS (Return On Ad Spend) bids</a>.\n\n**May 20, 2021**\n\n* Added support for <a href=\"#tag/Campaigns/operation/advertise_updateCampaignBudget\">updating a Campaign Budget</a>.\n\n**May 14, 2021**\n\n* Added support for <a href=\"#operation/advertise-replaceAssignedBudget\">assigning a Campaign Budget</a>.\n\n**May 7, 2021**\n\n* Added support for <a href=\"#operation/advertise-unassignBudget\">unassigning a Campaign Budget</a>.\n\n**May 6, 2021**\n\n* Added support for <a href=\"#operation/advertise-getAssignedBudget\">retrieving Assigned Budget</a>.\n\n**May 3, 2021**\n\n* Added support for <a href=\"#operation/advertise-listBudgets\">listing Campaign Budgets</a>.\n\n**April 28, 2021**\n\n* Added support for <a href=\"#tag/Apps/operation/advertise_listApps\">listing Apps</a>.\n\n**April 19, 2021**\n\n* Added billingType field to list campaigns endpoint.\n\n**April 8, 2021**\n\n* Unity Advertising Management API version 1 (beta) released.\n\n**February 17, 2021**\n\n* First draft of the version 1 of the Unity Advertising Management API.\n</details>\n\n# Guides\n\nThis section contains guides on how to use the API.\n\n## Uploading and Assigning Creatives\n\nCreatives and creative packs are the content of your ad campaigns. This article covers the following steps:\n\n* [Overview](#section/Guides/Creatives/Overview)\n* [Step 1: Upload Your Creatives](#section/Guides/Creatives/Step1)\n* [Step 2: Create a Creative Pack](#section/Guides/Creatives/Step2)\n* [Step 3: Assign a Creative Pack to a Campaign](#section/Guides/Creatives/Step3)\n\n### <a name=\"section/Guides/Creatives/Overview\"></a>Overview\n\nThe ad assets (files) such as videos, playables and end cards are managed using two concepts called\n`Creatives` and `Creative Packs`. Creatives directly hold your creative files while creative packs combine 1-3\ncreatives into a pack that can be assigned to one or more campaigns. Banner creative packs are the exception:\nthey hold 1-10 creatives, and neither they nor their creatives can be created through this API.\n\nThe process for creating and assigning creative packs to campaigns is as follows:\n\n```mermaid\n  graph LR\n  Upload[Upload creatives] --> Pack[Create a creative pack] --> Assign[Assign the creative pack<br>to a campaign]\n  classDef black fill:#000,color:#fff,stroke:#ddd,stroke-width:1px,line-height:21px;\n  class Upload,Pack,Assign black\n  click Upload \"#tag/Creatives/operation/advertise_createCreative\"\n  click Pack \"#tag/Creative-Packs/operation/advertise_createCreativePack\"\n```\n\n### <a name=\"section/Guides/Creatives/Step1\"></a>Step 1: Upload Your Creatives\n\nYou can upload your creatives by using the [Create Creative](#tag/Creatives/operation/advertise_createCreative) endpoint.\n\nThe following creative assets can be uploaded currently through the API:\n\n* **Square end card**: this creative type contains a single square shaped 800 × 800 image.\n* **End card pair**: this creative type contains a 600 × 800 portrait image and a 800 × 600 landscape image.\n* **Portrait video**: this creative type contains a 9:16 portrait video.\n* **Landscape video**: this creative type contains a 16:9 landscape video.\n* **Playable**: this creative type contains an MRAID 2.0 compliant HTML document in a landscape, portrait or responsive orientation. Refer to the [Creative packs documentation](https://docs.unity.com/acquire/manual/creative-packs).\n\nUsually you call the `Create Creative` endpoint once for each file you wish to upload. The only exception to this is\nthe end card pair creative which includes both portrait and landscape images in one creative.\n\n#### Upload a Video\n\nBelow is an example how the upload endpoint can be called using the command line command `curl`. To try\nit out, replace the `/path/to/your/file/myPortraitVideo.mp4` with your local video file path and replace\n`<ORGANIZATION_ID>`, `<SERVICE_ACCOUNT_CREDENTIALS>` and `<CAMPAIGN_SET_ID>` with values matching your organization and app.\n\n```\ncurl --verbose \\\n --form 'creativeInfo={\"name\": \"My Portrait Video\", \"language\": \"en\", \"video\": {\"fileName\":\"myPortraitVideo.mp4\"}}' \\\n --form \"videoFile=@/path/to/your/file/myPortraitVideo.mp4\" \\\n --header \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" \\\n https://services.api.unity.com/advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/creatives\n```\n\nAfter the upload has completed successfully, you will receive a HTTP `201` response with a response payload such as below:\n\n```JSON\n  {\n\"id\": \"5fd363cf5d84aa0ed76956b1\",\n\"name\": \"My Portrait Video\",\n\"language\": \"en\",\n\"type\": \"portraitVideo\",\n\"createdAt\": \"2020-12-11T12:19:29.004Z\",\n\"status\": \"uploaded\"\n  }\n```\n\n#### Upload a Square End Card\n\nUploading a square end card works in similar fashion as uploading videos but you'll need to adjust the request\nin the following way:\n\n1. Adjust the `creativeInfo` to contain a `squareEndCard` field instead of a `video` field.\n2. Instead of passing the file in a `videoFile` field, pass the file in a field called `squareEndCardFile`.\n\nExample:\n```\ncurl --verbose \\\n --form 'creativeInfo={\"name\":\"My End Card\", \"language\":\"en\", \"squareEndCard\": {\"fileName\":\"mySquareEndCard.jpeg\"}}' \\\n --form \"squareEndCardFile=@/path/to/your/file/mySquareEndCard.jpeg\" \\\n --header \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" \\\n https://services.api.unity.com/advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/creatives\n```\n\n#### Upload an End Card Pair\n\nUploading an end card pair works in similar fashion as uploading videos and square end card but you'll need to\ninclude both end card files in the request:\n\n```\ncurl --verbose \\\n   --form 'creativeInfo={\"name\":\"My End Card Pair\", \"language\":\"en\", \"portraitEndCard\": {\"fileName\":\"myPortraitEndCard.jpeg\" }, \"landscapeEndCard\": {\"fileName\":\"myLandscapeEndCard.jpeg\"}}' \\\n   --form \"portraitEndCardFile=@/path/to/your/file/600x800.jpeg\" \\\n   --form \"landscapeEndCardFile=@/path/to/your/file/800x600.jpeg\" \\\n   --header \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" \\\n   https://services.api.unity.com/advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/creatives\n```\n\n#### Creative Status\n\nAfter having been uploaded, all new creatives undergo a [content moderation process](https://docs.unity.com/grow/en-us/acquire/creatives/moderation/creative-moderation)\nto ensure that they follow Unity's advertising [content policy](https://unity.com/legal/content-policy).\nBefore entering the moderation queue, the video creatives go through a processing state that can take few minutes.\n\nYou can check the latest status of the uploaded creative with [Get Creative](#tag/Creatives/operation/advertise_getCreative) endpoint.\n\nCreatives can be added into a creative pack immediately after they have been uploaded. It isn't necessary to\nwait for the moderation to complete. However, a creative pack can go live only after all its creatives have\npassed the moderation.\n\n### <a name=\"section/Guides/Creatives/Step2\"></a>Step 2: Create a Creative Pack\n\nAfter you've uploaded your creatives, you can use [Create Creative Pack](#tag/Creative-Packs/operation/advertise_createCreativePack)\nendpoint to create a creative pack out of them. A creative pack combines 1-3 creatives into one entity\nthat can be assigned to one or more campaigns.\n\nThe following creative combinations are allowed when creating a creative pack through the API:\n\n* Portrait video  + end card\n* Landscape video + end card\n* Portrait video  + landscape video + end card\n* Responsive playable\n* Portrait playable\n* Landscape playable\n* Portrait playable + landscape playable\n\nWhile only one video or playable is required, uploading one for each orientation yields better optimization.\nWhen a creative pack contains both, Unity’s valuation algorithm selects the best orientation to display.\n\nBelow is an example that creates a creative pack that contains one portrait video (with ID `5fd363cf5d84aa0ed76956b1`)\nand one square end card (with ID `5feb40a6ff3d91a3af53c678`):\n\n```\ncurl --verbose \\\n --request POST \\\n --data '{\"name\": \"Portrait video with square end card\", \"creativeIds\": [\"5fd363cf5d84aa0ed76956b1\", \"5feb40a6ff3d91a3af53c678\"], \"type\": \"video\"}' \\\n --header \"Content-Type: application/json\" \\\n --header \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" \\\n https://services.api.unity.com/advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/creative-packs\n```\n\nReplace the `creativeIds`, `<ORGANIZATION_ID>`, `<CAMPAIGN_SET_ID>` and `<SERVICE_ACCOUNT_CREDENTIALS>` with values that match your app and organization.\n\nFor a successful request, the response HTTP status code is `201` and the response body follows following format:\n\n```JSON\n{\n  \"id\": \"5feb4574ff3d91a3af53c67e\",\n  \"name\": \"Video with end card\",\n  \"type\": \"video\",\n  \"creativeIds\": [\n  \"5fd363cf5d84aa0ed76956b1\",\n  \"5feb40a6ff3d91a3af53c678\"\n  ]\n}\n```\n\n### <a name=\"section/Guides/Creatives/Step3\"></a>Step 3: Assign a Creative Pack to a Campaign\n\nTo assign a creative pack to your campaign, use the <a href=\"#tag/Campaigns/operation/advertise_assignCreativePack\">assign Creative Pack endpoint</a>.\n\nIf your creative pack's ID is for example `5f15703772f10b00138f6d8d`, you can assign it to your campaign with a POST\nrequest:\n\n```\ncurl --verbose \\\n --request POST \\\n --data '{\"id\": \"5f15703772f10b00138f6d8d\"}' \\\n --header \"Content-Type: application/json\" \\\n --header \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" \\\n https://services.api.unity.com/advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/campaigns/<CAMPAIGN_ID>/assigned-creative-packs\n```\n\nThe currently assigned creative packs can be listed with a GET query:\n\n```\ncurl --header \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" \\\n https://services.api.unity.com/advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/campaigns/<CAMPAIGN_ID>/assigned-creative-packs\n```\n\nThe response contains a list of creative pack IDs.\n\nA campaign must contain at least one approved creative pack in order to go live. If your live campaign includes a\nmix of approved and pending creative packs, the pending ones will automatically run when approved.\n\nTo unassign a creative pack from a campaign, use the <a href=\"#tag/Campaigns/operation/advertise_unassignCreativePack\">unassign Creative Pack endpoint</a>.\n\nYou can unassign a creative pack with a DELETE query that includes the creative pack's ID in the URL:\n\n```\ncurl --verbose \\\n --request DELETE \\\n --header \"Authorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\" \\\n https://services.api.unity.com/advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/campaigns/<CAMPAIGN_ID>/assigned-creative-packs/<ASSIGNED_CREATIVE_PACK_ID>\n```\n"
  },
  "servers": [
    {
      "url": "https://services.api.unity.com",
      "description": "Production server"
    }
  ],
  "security": [
    {
      "Authentication": []
    }
  ],
  "tags": [
    {
      "name": "Apps",
      "description": "Manage your Apps with these APIs.\n"
    },
    {
      "name": "Bids",
      "description": "Manage bids and source bids for your CPI campaigns with these APIs.\n\nTo make bulk bid changes to large campaigns without code, use [Bulk campaign management](https://docs.unity.com/acquire/manual/bulk-campaign-management).\n\n<div style=\"background-color: #f9f9f9; padding: 1em; font-size: 0.95em;\">\n  <h4>Note about iOS Campaigns</h4>\n\n  All campaigns are now billed by Cost per Impression (CPM).\n\n  This is a billing method where you are charged based on the total number of impressions your campaign receives.\n  This means that CPI campaigns are now [target CPI campaigns](https://docs.unity.com/acquire/manual/campaigns).\n  Your campaign optimization goals, such as Installs, ROAS, or Retention, do not change. For more information, refer to the [Advertise FAQs](https://docs.unity.com/acquire/manual/FAQs).\n\n  Bids are now Target CPI (tCPI) bids, the average amount you wish to pay per install. Target CPI is a bidding\n  strategy that sets bids to help you get as many conversions as possible within a tight range of the target\n  cost-per-install you set. This strategy automatically optimizes bidding for your ad each time it is eligible to\n  appear. Target CPI (tCPI) bids are set the same way as CPI bids via APIs.\n</div>\n"
    },
    {
      "name": "Campaigns",
      "description": "Manage your advertisement campaigns with these APIs.\n\nTo make bulk changes to large campaigns without code, use [Bulk campaign management](https://docs.unity.com/acquire/manual/bulk-campaign-management).\n"
    },
    {
      "name": "Creatives",
      "description": "Manage your creatives (files) such as videos and end cards with these APIs.\n\nFor more information, refer to the \n<a href=\"https://docs.unity.com/acquire/manual/creative-packs\" target=\"_blank\">Creative packs documentation</a>.\n"
    },
    {
      "name": "Creative Packs",
      "description": "Manage your creative packs with these APIs.\n\nFor more information, refer to the\n<a href=\"https://docs.unity.com/acquire/manual/creative-packs\" target=\"_blank\">Creative packs documentation</a>.\n"
    }
  ],
  "paths": {
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        }
      ],
      "get": {
        "summary": "Get App",
        "description": "This endpoint returns the app information for a given app ID.\n",
        "operationId": "advertise-getApp",
        "tags": [
          "Apps"
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.app"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "patch": {
        "summary": "Update App",
        "description": "This endpoint is used to update an App.\n\n**Note**: this endpoint supports partial updates.\n",
        "operationId": "advertise-updateApp",
        "tags": [
          "Apps"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.updateAppRequestBody"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.app"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "delete": {
        "summary": "Delete App",
        "description": "This endpoint is used to delete an App.\n\n**Note:** all campaigns, bids and creative packs belonging to the app will also be deleted. Deleted apps cannot be recovered.\n",
        "operationId": "advertise-deleteApp",
        "tags": [
          "Apps"
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        }
      ],
      "get": {
        "summary": "List Apps",
        "description": "This endpoint returns all available apps\n",
        "operationId": "advertise-listApps",
        "tags": [
          "Apps"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/advertise.offset"
          },
          {
            "$ref": "#/components/parameters/advertise.limit"
          },
          {
            "$ref": "#/components/parameters/advertise.filter"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.appsResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "post": {
        "summary": "Create App",
        "description": "This endpoint creates a new app\n",
        "operationId": "advertise-createApp",
        "tags": [
          "Apps"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.createAppRequestBody"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.app"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/creatives": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        }
      ],
      "get": {
        "summary": "List Creatives",
        "description": "This endpoint returns all available creatives that are under the given app.\n",
        "operationId": "advertise-listCreatives",
        "tags": [
          "Creatives"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/advertise.offset"
          },
          {
            "$ref": "#/components/parameters/advertise.creativeLimit"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.creativesResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "post": {
        "summary": "Create Creative",
        "description": "Upload an end card or video creative using this endpoint.\n\nThree different types of creatives can currently be created through this API:\n\n* **Square end card**:  a single square shaped 800 × 800 image.\n* **End card pair**:  a 600 × 800 portrait image and a 800 × 600 landscape image.\n* **Video**:  contains either a 9:16 portrait video or a 16:9 landscape video.\n* **Playable**: contains an MRAID 2.0 compliant HTML document in a portrait, landscape or responsive orientation. Refer to the [Creative packs documentation](https://docs.unity.com/acquire/manual/creative-packs).\n\nEach creative type requires a slightly different JSON payload and a different set of binary files:\n\n* one image file for a square end card,\n* two image files for an end card pair,\n* one video file for a video creative.\n* one HTML file for a playable creative.\n\nTo create a creative, you will need to send a HTTP request with content type of `multipart/form-data`\nto the API endpoint. The first part of the multipart form should contain a field named `creativeInfo` that\ncontains JSON metadata about the creative, followed by one or more additional parts containing the binary\ndata for each creative file.\n\n**Example**\n\nFor a square end card the raw HTTP request could look for example following:\n```\nPOST /advertise/v1/organizations/<ORGANIZATION_ID>/apps/<CAMPAIGN_SET_ID>/creatives HTTP/1.1\nHost: services.api.unity.com:443\nAuthorization: Basic <SERVICE_ACCOUNT_CREDENTIALS>\nContent-Type: multipart/form-data; boundary=--------------------------371131627955007232942795\nContent-Length: 51165\n----------------------------371131627955007232942795\nContent-Disposition: form-data; name=\"creativeInfo\"\nContent-Type: application/json\n\n{\n  \"name\": \"My Creative\",\n  \"language\": \"en\",\n  \"squareEndCard\": {\n    \"fileName\": \"myCreative.jpeg\"\n  }\n}\n----------------------------371131627955007232942795\nContent-Disposition: form-data; name=\"squareEndCardFile\"; filename=\"myCreative.jpeg\"\n\n<IMAGE_BINARY_DATA>\n----------------------------371131627955007232942795--\n```\n\nNotice that the place holders `<ORGANIZATION_ID>`, `<CAMPAIGN_SET_ID>`, `<SERVICE_ACCOUNT_CREDENTIALS>` and `<IMAGE_BINARY_DATA>` need to be replaced with valid values.\n\nWhen uploading creative assets, ensure that you follow Unity’s advertising [content policy](https://unity.com/legal/content-policy).\n\nA continuous data flow is expected when uploading the file. The creative upload is allowed to take at most 5 minutes.\nThis means that if you are creating a creative that contains a video that has the maximum file size of 100 MB then your average upload speed must at least 2.7 Mbps.\nIf the upload takes longer than 5 minutes then the request will fail.  If the upload halts (no bytes are transferred) for over 30 seconds then the request will fail.\n\nIf the same files have already been uploaded as part of a previous creative, the existing creative is returned and no new one is created.\n",
        "operationId": "advertise-createCreative",
        "tags": [
          "Creatives"
        ],
        "requestBody": {
          "description": "OK",
          "content": {
            "multipart/form-data": {
              "schema": {
                "$ref": "#/components/schemas/advertise.createCreativeRequestBody"
              },
              "encoding": {
                "creativeInfo": {
                  "contentType": "application/json"
                },
                "squareEndCardFile": {
                  "contentType": "image/*"
                },
                "portraitEndCardFile": {
                  "contentType": "image/*"
                },
                "landscapeEndCardFile": {
                  "contentType": "image/*"
                },
                "videoFile": {
                  "contentType": "video/*"
                },
                "playableFile": {
                  "contentType": "text/html"
                }
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.creative"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "413": {
            "$ref": "#/components/responses/PayloadTooLargeError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          },
          "504": {
            "$ref": "#/components/responses/GatewayTimeoutError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/creatives/{creativeId}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        },
        {
          "$ref": "#/components/parameters/advertise.creativeId"
        }
      ],
      "get": {
        "summary": "Get Creative",
        "description": "This endpoint returns a creative by the creative ID and campaign set ID.\n",
        "operationId": "advertise-getCreative",
        "tags": [
          "Creatives"
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.creative"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/creative-packs": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        }
      ],
      "get": {
        "summary": "List Creative Packs",
        "description": "This endpoint returns creative packs that are under the given app.\n",
        "operationId": "advertise-listCreativePacks",
        "tags": [
          "Creative Packs"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/advertise.offset"
          },
          {
            "$ref": "#/components/parameters/parameters_advertise.limit"
          },
          {
            "$ref": "#/components/parameters/parameters_advertise.filter"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.creativePacksResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "post": {
        "summary": "Create Creative Pack",
        "description": "Create a creative pack using this endpoint.\n\nThree different types of creative packs can be currently created through this API:\n\n* **video**: this creative pack type contains a single end card creative (square end card or end card pair) and one or two video creatives (one end card + 1-2 videos).\n* **playable**: this creative pack type contains one or two playable creatives.\n* **video and playable**: this creative pack type contains one or two video creatives and a single responsive playable.\n\nEach creative pack type requires different `creativeIds` which have to match with the given creative pack type.\nIf the creatives referenced by the `creativeIds` do not match with the creative pack's `type` then the API\nwill respond with `400` bad request.\n\nAvailable creatives for your app can be listed via <a href=\"#operation/advertise-listCreatives\">list Creatives</a> endpoint.\n",
        "operationId": "advertise-createCreativePack",
        "tags": [
          "Creative Packs"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.createCreativePackRequestBody"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.creativePack"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/creative-packs/{creativePackId}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        },
        {
          "$ref": "#/components/parameters/advertise.creativePackId"
        }
      ],
      "get": {
        "summary": "Get Creative Pack",
        "description": "This endpoint returns a creative pack by the creative pack ID and campaign set ID.\n",
        "operationId": "advertise-getCreativePack",
        "tags": [
          "Creative Packs"
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.creativePack"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "patch": {
        "summary": "Update Creative Pack",
        "description": "This endpoint is used to update a creative pack.\n\n**Note**: The `campaignIds` in the response is always empty.\n",
        "operationId": "advertise-updateCreativePack",
        "tags": [
          "Creative Packs"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.updateCreativePackRequestBody"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.creativePack"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "delete": {
        "summary": "Delete Creative Pack",
        "description": "This endpoint removes a creative pack by the creative pack ID and campaign set ID.\n",
        "operationId": "advertise-deleteCreativePack",
        "tags": [
          "Creative Packs"
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/campaigns": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        }
      ],
      "get": {
        "summary": "List Campaigns",
        "description": "This endpoint returns campaigns for the given app.",
        "operationId": "advertise-listCampaigns",
        "tags": [
          "Campaigns"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/advertise.campaigns.filter"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.campaignsResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "post": {
        "summary": "Create Campaign",
        "description": "This endpoint is used to create a campaign.\n\nIn order to complete the campaign setup, take the following steps:\n  1. You can <a href=\"#operation/advertise-createCreative\">Upload Creatives</a> or use the old ones if you already have uploaded them.\n  2. You can <a href=\"#operation/advertise-createCreativePack\">Create Creative Pack</a> or use any approved creative pack you already have.\n  3. You should <a href=\"#operation/advertise-assignCreativePack\">Assign Creative Pack</a> to the campaign.\n  4. Depending on the `goal` of your campaign you need to update CPI/ROAS/Retention bids by calling the right <a href=\"#tag/Bids\">Bids endpoint</a>.\n  5. Finally if you prepared all requirements you can change the `enabled` status by calling the <a href=\"#operation/advertise-updateCampaign\">Update Campaign</a> endpoint.\n\n**Note**: The campaign must have the below prerequisites to go live:\n  - At least one assigned and approved creative pack.\n  - Tracking attribution links.\n  - Specify countries you would like to advertise in.\n  - The organization is required to have a budget and also, you can optionally <a href=\"#operation/advertise-updateCampaignBudget\">update</a> the campaign-level budget.\n\n**Note**: If null values are passed for the links (`attributionClickUrl` or `attributionStartUrl`), and the app that campaign belongs to has one or many app-level attribution urls set, a modified campaign would automatically get the app-level attribution url values.\n",
        "operationId": "advertise-createCampaign",
        "tags": [
          "Campaigns"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.createCampaignRequestBody"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.campaign"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/campaigns/{campaignId}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignId"
        }
      ],
      "get": {
        "summary": "Get Campaign",
        "description": "This endpoint returns the campaign information for a given campaign id.",
        "operationId": "advertise-getCampaign",
        "tags": [
          "Campaigns"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/advertise.includeFields"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.campaign"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "patch": {
        "summary": "Update Campaign",
        "description": "This endpoint is used to update a campaign.\n\n**Note**: this endpoint supports partial updates. The payload can contain, for example, only a new value for the `enabled` field.\n\n**Note**: If null values are passed for the links (`attributionClickUrl` or `attributionStartUrl`), and the app that campaign belongs to has one or many app-level attribution urls set, a modified campaign would automatically get the app-level attribution url values.\n",
        "operationId": "advertise-updateCampaign",
        "tags": [
          "Campaigns"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.updateCampaignRequestBody"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.campaign"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "delete": {
        "summary": "Delete Campaign",
        "description": "This endpoint is used to delete a campaign.\n",
        "operationId": "advertise-deleteCampaign",
        "tags": [
          "Campaigns"
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/campaigns/{campaignId}/assigned-creative-packs": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignId"
        }
      ],
      "get": {
        "summary": "List Assigned Creative Packs",
        "description": "This endpoint returns creative packs that are assigned to a campaign.\n\n**Note**: you can also use the <a href=\"#operation/advertise-listCreativePacks\">list Creative Packs</a> endpoint\nto check which creative packs are currently assigned to which campaigns.\n",
        "operationId": "advertise-listAssignedCreativePacks",
        "tags": [
          "Campaigns"
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.assignedCreativePacksResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "post": {
        "summary": "Assign Creative Pack",
        "description": "Assign a creative pack to a campaign.\n\n<div style=\"background-color: #f9f9f9; padding: 1em; font-size: 0.95em;\">\n  <h4>Note about iOS Campaigns</h4>\n\n  Please note that there is a limit of 50 creative pack assignments in apps sharing the same store id that you\n  can use on your live campaigns for iOS apps. You can find more information about this limit\n  <a href=\"https://resources.unity.com/ios-14-resources/campaign-management-best-practices#5-limit-campaigns\" target=\"_blank\">here</a>.\n</div>\n",
        "operationId": "advertise-assignCreativePack",
        "tags": [
          "Campaigns"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.assignCreativePackRequestBody"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.assignedCreativePack"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/campaigns/{campaignId}/assigned-creative-packs/{assignedCreativePackId}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignId"
        },
        {
          "$ref": "#/components/parameters/advertise.assignedCreativePackId"
        }
      ],
      "delete": {
        "summary": "Unassign Creative Pack",
        "description": "Unassign a creative pack from a campaign.\n",
        "operationId": "advertise-unassignCreativePack",
        "tags": [
          "Campaigns"
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/campaigns/{campaignId}/cpi-bids": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignId"
        }
      ],
      "get": {
        "summary": "List CPI Bids",
        "description": "This endpoint returns the campaign’s CPI bids; \nincluding bids for static bidding CPI campaigns and max bids for automated bidding CPI campaigns.\n\n<div style=\"background-color: #f9f9f9; padding: 1em; font-size: 0.95em;\">\n  <h4>Note about iOS Campaigns</h4>\n\n  CPI campaigns are now target CPI campaigns while your campaign optimization goals,\n  such as Installs, ROAS or Retention, do not change.\n\n  Bids are now Target CPI (tCPI) bids, the average amount you wish to pay per install. Target CPI is a\n  bidding strategy that sets bids to help you get as many conversions as possible within a tight range of the\n  target cost-per-install you set. This strategy automatically optimizes bidding for your ad each time it is\n  eligible to appear. Target CPI (tCPI) bids are set the same way as CPI bids via APIs.\n</div>\n",
        "operationId": "advertise-listCpiBids",
        "tags": [
          "Bids"
        ],
        "responses": {
          "200": {
            "description": "List of CPI bids",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.cpiBidsResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "put": {
        "summary": "Update CPI Bids",
        "description": "This endpoint replaces a campaign’s CPI bids with a new set of bids. \nApplicable for bids update on static bidding CPI campaigns \nand max bid update for automated bidding CPI campaigns. \n\nTo remove all the CPI bids of a campaign, send an empty array in the request body.\n\n<div style=\"background-color: #f9f9f9; padding: 1em; font-size: 0.95em;\">\n  <h4>Note about iOS Campaigns</h4>\n\n  CPI campaigns are now target CPI campaigns while your campaign optimization goals,\n  such as Installs, ROAS or Retention, do not change.\n\n  Bids are now Target CPI (tCPI) bids, the average amount you wish to pay per install. Target CPI is a\n  bidding strategy that sets bids to help you get as many conversions as possible within a tight range of the\n  target cost-per-install you set. This strategy automatically optimizes bidding for your ad each time it is\n  eligible to appear. Target CPI (tCPI) bids are set the same way as CPI bids via APIs.\n</div>\n",
        "operationId": "advertise-replaceCpiBids",
        "tags": [
          "Bids"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.cpiBids"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successfully updated the CPI bids",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.cpiBidsResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      },
      "patch": {
        "summary": "Update Partial CPI Bids",
        "description": "This endpoint partially updates a campaign’s CPI bids with the specified bid changes. \nApplicable for bids update on static bidding CPI campaigns \nand max bid update for automated bidding CPI campaigns. \n\nTo remove a specific CPI bid, send the country code with a **null bid** value in the request body.\n\n<div style=\"background-color: #f9f9f9; padding: 1em; font-size: 0.95em;\">\n  <h4>Note about iOS Campaigns</h4>\n\n  CPI campaigns are now target CPI campaigns while your campaign optimization goals,\n  such as Installs, ROAS or Retention, do not change.\n\n  Bids are now Target CPI (tCPI) bids, the average amount you wish to pay per install. Target CPI is a\n  bidding strategy that sets bids to help you get as many conversions as possible within a tight range of the\n  target cost-per-install you set. This strategy automatically optimizes bidding for your ad each time it is\n  eligible to appear. Target CPI (tCPI) bids are set the same way as CPI bids via APIs.\n</div>\n",
        "operationId": "advertise-patchCpiBids",
        "tags": [
          "Bids"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/advertise.cpiBidsPatch"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successfully updated the CPI bids",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/advertise.cpiBidsResponseBody"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ValidationError.v1"
          },
          "401": {
            "$ref": "#/components/responses/AuthenticationError.v1"
          },
          "403": {
            "$ref": "#/components/responses/AuthorizationError.v1"
          },
          "404": {
            "$ref": "#/components/responses/NotFoundError.v1"
          },
          "429": {
            "$ref": "#/components/responses/TooManyRequestsError.v1"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError.v1"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError.v1"
          }
        }
      }
    },
    "/advertise/v1/organizations/{organizationId}/apps/{campaignSetId}/campaigns/{campaignId}/source-bids": {
      "parameters": [
        {
          "$ref": "#/components/parameters/advertise.organizationCoreId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignSetId"
        },
        {
          "$ref": "#/components/parameters/advertise.campaignId"
        }
      ],
      "get": {
        "summary": "List Source Bids",
[...]
